from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Int, File, String, Float

Preprocess_Novoalign_Sh_V0_1_0 = CommandToolBuilder(tool="preprocess_novoalign.sh", base_command=["preprocess_novoalign.sh"], inputs=[ToolInput(tag="in_output_bam", input_type=Boolean(optional=True), prefix="-b", doc=InputDocumentation(doc="output BAM")), ToolInput(tag="in_print_header_only", input_type=Boolean(optional=True), prefix="-H", doc=InputDocumentation(doc="print header only (no alignments)")), ToolInput(tag="in_input_is_sam", input_type=Boolean(optional=True), prefix="-S", doc=InputDocumentation(doc="input is SAM")), ToolInput(tag="in_uncompressed_bam_output", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="uncompressed BAM output (force -b)")), ToolInput(tag="in_fast_compression_force", input_type=Boolean(optional=True), prefix="-1", doc=InputDocumentation(doc="fast compression (force -b)")), ToolInput(tag="in_output_flag_hex_specific", input_type=Boolean(optional=True), prefix="-x", doc=InputDocumentation(doc="output FLAG in HEX (samtools-C specific)")), ToolInput(tag="in_output_flag_string_specific", input_type=Boolean(optional=True), prefix="-X", doc=InputDocumentation(doc="output FLAG in string (samtools-C specific)")), ToolInput(tag="in_print_only_count", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="print only the count of matching records")), ToolInput(tag="in_collapse_cigar_operation", input_type=Boolean(optional=True), prefix="-B", doc=InputDocumentation(doc="collapse the backward CIGAR operation")), ToolInput(tag="in_at", input_type=Int(optional=True), prefix="-@", doc=InputDocumentation(doc="number of BAM compression threads [0]")), ToolInput(tag="in_output_alignments_overlapping", input_type=File(optional=True), prefix="-L", doc=InputDocumentation(doc="output alignments overlapping the input BED FILE [null]")), ToolInput(tag="in_list_reference_names", input_type=File(optional=True), prefix="-t", doc=InputDocumentation(doc="list of reference names and lengths (force -S) [null]")), ToolInput(tag="in_reference_sequence_file", input_type=File(optional=True), prefix="-T", doc=InputDocumentation(doc="reference sequence file (force -S) [null]")), ToolInput(tag="in_output_file_name", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="output file name [stdout]")), ToolInput(tag="in_list_read_groups", input_type=File(optional=True), prefix="-R", doc=InputDocumentation(doc="list of read groups to be outputted [null]")), ToolInput(tag="in_required_flag_unset", input_type=Int(optional=True), prefix="-f", doc=InputDocumentation(doc="required flag, 0 for unset [0]")), ToolInput(tag="in_filtering_flag_unset", input_type=Int(optional=True), prefix="-F", doc=InputDocumentation(doc="filtering flag, 0 for unset [0]")), ToolInput(tag="in_minimum_mapping_quality", input_type=Int(optional=True), prefix="-q", doc=InputDocumentation(doc="minimum mapping quality [0]")), ToolInput(tag="in_only_output_reads_library_str", input_type=String(optional=True), prefix="-l", doc=InputDocumentation(doc="only output reads in library STR [null]")), ToolInput(tag="in_only_output_reads_read_str", input_type=String(optional=True), prefix="-r", doc=InputDocumentation(doc="only output reads in read group STR [null]")), ToolInput(tag="in_fraction_templates_subsample", input_type=Float(optional=True), prefix="-s", doc=InputDocumentation(doc="fraction of templates to subsample; integer part as seed [-1]")), ToolInput(tag="in_sam_tools", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_view", input_type=String(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_in_dot_bam", input_type=String(), position=2, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output_file_name", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file_name", type_hint=File()), doc=OutputDocumentation(doc="output file name [stdout]"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Preprocess_Novoalign_Sh_V0_1_0().translate("wdl", allow_empty_container=True)

